#include <stdio.h>
/* add_bitw.c : file sorgente di un programma che effettua l'addizione
                tra due numeri interi senza utilizzare l'operatore +,
                ma facendo ricorso in modo opportuno agli operatori
                bitwise (= bit a bit) */
/* Definizione dei prototipi delle funzioni */
unsigned int addbitw(unsigned int add1,unsigned int add2);
int main()
{
  /* Definizione delle variabili:
     num1,num2,num3 = tre numeri */
  unsigned int num1,num2,num3;
  /* Fase di input dei due addendi*/
  printf("Dammi due numeri non negativi: ");
  scanf("%u %u",&num1,&num2);
  /* Somma dei due numeri utilizzando solo operatori bitwise */
  num3 = addbitw(num1,num2);
  /* Stampa del risultato */
  printf("Risultato della somma (effettuata con operatori bitwise): %u\n",
	 num3);
  exit(0);
}
/* ### */
unsigned int addbitw(add1,add2)
    unsigned int add1;
    unsigned int add2;
{
  /* Definizione della variabile che verra' restituita come risultato */
  unsigned int ris;
  /* Definizione di un contatore i */
  int i;
  /* Definizione di un numero nel quale mettero' i riporti */
  unsigned int rip;
  /* Inizio del ciclo di istruzioni da eseguire almeno una volta
     e da ripetersi finche' non si azzerano tutti i riporti */
  do {
    /* Poniamo ogni cifra del risultato uguale a 1 se le corrispondenti 
       cifre dei due addendi sono diverse, altrimenti la poniamo uguale a 0 */
    ris = add1 ^ add2;
    /* Se entrambe le cifre dei due addendi che corrispondono a una fissata
       posizione sono uguali ad 1 allora poniamo uguale ad 1 il riporto
       di posto successivo, altrimenti la poniamo uguale a 0 */
    rip = add1 & add2;
    rip <<= 1;
    /* Poniamo il primo addendo uguale al risultato */
    add1 = ris;
    /* Poniamo il secondo addendo uguale al riporto */
    add2 = rip;
    /* usciamo dal ciclo solo se il riporto e' uguale a 0 (=FALSE) */
  }  while(rip);
  return(ris);
}
