#include <stdio.h>
/* add_bin.c : file sorgente di un programma che effettua l'addizione
               tra due numeri interi senza utilizzare l'operatore +,
               ma facendo ricorso in modo opportuno agli operatori
               logici applicati alle rappresentazioni in forma binaria
               dei numeri stessi */
/* Definizione dei prototipi delle funzioni */
void addbin(unsigned char addbin1[],unsigned char addbin2[],
	    unsigned char risbin[]);
unsigned int bin2dec(unsigned char numbin[]);
void dec2bin(unsigned int numdec, unsigned char numbin[]);
int main()
{
  /* Definizione delle variabili:
     numdec1,numdec2,numdec3 = numeri in formato decimale
     numbin1,numbin2,numbin3 = vettori di numeri in formato binario */
  unsigned int numdec1,numdec2,numdec3;
  unsigned char numbin1[32],numbin2[32],numbin3[32];
  /* Fase di input dei due addendi in formato decimale */

  /* Conversione da rappresentazione decimale a binaria del primo addendo */

  /* Conversione da rappresentazione decimale a binaria del secondo addendo */

  /* Somma delle rappresentazioni binarie utilizzando solo operatori logici */

  /* Conversione del risultato da rappresentazione binaria a decimale */

  /* Stampa del risultato in rappresentazione decimale */

  exit(0);
}
/* ### */
void addbin(addbin1,addbin2,risbin)
    unsigned char addbin1[];
    unsigned char addbin2[];
    unsigned char risbin[];
{
  /* Definizione di un contatore i */
  int i;
  /* Definizione di un vettore nel quale mettero' i riporti */
  unsigned char ripbin[32];
  /* Definizione di una variabile flag */
  unsigned char flag;
  /* Inizio del ciclo di istruzioni da eseguire almeno una volta
     e da ripetersi finche' non si azzerano tutti i riporti */

  {
    /* Poniamo ogni cifra del risultato uguale a 1 se le corrispondenti 
       cifre dei due addendi sono diverse, altrimenti la poniamo uguale a 0 */

    /* Azzeriamo la prima cifra dei riporti */

    /* Se entrambe le cifre dei due addendi che corrispondono a una fissata
       posizione sono uguali ad 1 allora poniamo uguale ad 1 il riporto
       di posto successivo, altrimenti lo poniamo uguale a 0 */

    /* Poniamo il primo addendo uguale al risultato */

    /* Poniamo il secondo addendo uguale ai riporti */

    /* Poniamo la variabile flag uguale a 0 (=FALSE) se tutti  i riporti
       sono uguali a 0 e poniamo flag uguale a 1 (=TRUE) altrimenti */


    /* usciamo dal ciclo solo se la variabile flag e' uguale a 0 (=FALSE) */
  }
  return;
}
/* ### */
unsigned int bin2dec(numbin)
    unsigned char numbin[];
{
  /* Definizione della variabile contenente il risultato */
  unsigned int ris;
  /* Definizione di un contatore i */
  int i;
  /* Definizione di una variabile che contiene le potenze di 2 */
  unsigned int pot2;
  /* Azzeramento del risultato */
  ris = 0;
  /* Inizializzazione a 1 delle potenze di 2 */
  pot2 = 1;
  /* Ciclo su i che indica tutte le cifre della rappresentazione binaria */
  for(i=0;i<32;i++) {
    /* Incremento il risultato aggiungendo
       il prodotto tra la i-esima cifra binaria e la i-esima potenza di 2 */
    ris += numbin[i] * pot2;
    /* Passo alla potenza di 2 successiva */
    pot2 *= 2;
  }
  /* restituisco il valore del risultato alla funzione chiamante */
  return(ris);
}
/* ### */
void dec2bin(numdec,numbin)
    unsigned int numdec;
    unsigned char numbin[];
{
  /* Definizione di un contatore i */
  int i;
  /* Ciclo su i che indica tutte le cifre della rappresentazione binaria */
  for(i=0;i<32;i++) {
    /* Pongo la i-esima cifra binaria uguale al resto di numdec / 2 */
    numbin[i] = numdec % 2;
    /* Ridefinisco numdec uguale al quoziente di numdec / 2 */
    numdec /= 2;
  }
  return;
}
