#include <stdio.h>
/* mol_bin.c : file sorgente di un programma che effettua la
               moltiplicazione tra due numeri interi senza utilizzare
               l'operatore *, ma facendo ricorso in modo opportuno
               agli operatori logici applicati alle rappresentazioni
               in forma binaria dei numeri stessi */
/* Definizione dei prototipi delle funzioni */
void addbin(unsigned char addbin1[],unsigned char addbin2[],
	    unsigned char risbin[]);
unsigned int bin2dec(unsigned char numbin[]);
void dec2bin(unsigned int numdec, unsigned char numbin[]);
void molbin(unsigned char fatbin1[],unsigned char fatbin2[],
	    unsigned char risbin[]);
int main()
{
  /* Definizione delle variabili:
     numdec1,numdec2,numdec3 = numeri in formato decimale
     numbin1,numbin2,numbin3 = vettori di numeri in formato binario */
  unsigned int numdec1,numdec2,numdec3;
  unsigned char numbin1[32],numbin2[32],numbin3[32];
  /* Fase di input dei due addendi in formato decimale */
  printf("Dammi due numeri non negativi: ");
  scanf("%u %u",&numdec1,&numdec2);
  /* Conversione da rappresentazione decimale a binaria del primo addendo */

  /* Conversione da rappresentazione decimale a binaria del secondo addendo */

  /* Prodotto delle rappresentazioni binarie utilizzando solo
     operatori logici */

  /* Conversione del risultato da rappresentazione binaria a decimale */

  /* Stampa del risultato in rappresentazione decimale */

  exit(0);
}
/* ### */
void addbin(addbin1,addbin2,risbin)
    unsigned char addbin1[];
    unsigned char addbin2[];
    unsigned char risbin[];
{
  /* Definizione di un contatore i */
  int i;
  /* Definizione di un vettore nel quale mettero' i riporti */
  unsigned char ripbin[32];
  /* Definizione di una variabile flag */
  unsigned char flag;
  /* Inizio del ciclo di istruzioni da eseguire almeno una volta
     e da ripetersi finche' non si azzerano tutti i riporti */
  do {
    /* Poniamo ogni cifra del risultato uguale a 1 se le corrispondenti 
       cifre dei due addendi sono diverse, altrimenti la poniamo uguale a 0 */
    for(i=0;i<32;i++)   risbin[i] = addbin1[i] ^ addbin2[i];
    /* Azzeriamo la prima cifra dei riporti */
    ripbin[0] = 0;
    /* Se entrambe le cifre dei due addendi che corrispondono a una fissata
       posizione sono uguali ad 1 allora poniamo uguale ad 1 il riporto
       di posto successivo, altrimenti lo poniamo uguale a 0 */
    for(i=0;i<32;i++)  ripbin[i+1] = addbin1[i] && addbin2[i];
    /* Poniamo il primo addendo uguale al risultato */
    for(i=0;i<32;i++)  addbin1[i] = risbin[i];
    /* Poniamo il secondo addendo uguale ai riporti */
    for(i=0;i<32;i++)  addbin2[i] = ripbin[i];
    /* Poniamo la variabile flag uguale a 0 (=FALSE) se tutti  i riporti
       sono uguali a 0 e poniamo flag uguale a 1 (=TRUE) altrimenti */
    flag = 0;
    for(i=1;i<32;i++)  flag = flag || ripbin[i];
    /* usciamo dal ciclo solo se la variabile flag e' uguale a 0 (=FALSE) */
  }  while(flag);
  return;
}
/* ### */
unsigned int bin2dec(numbin)
    unsigned char numbin[];
{
  /* Definizione della variabile contenente il risultato */
  unsigned int ris;
  /* Definizione di un contatore i */
  int i;
  /* Definizione di una variabile che contiene le potenze di 2 */
  unsigned int pot2;
  /* Azzeramento del risultato */
  ris = 0;
  /* Inizializzazione a 1 delle potenze di 2 */
  pot2 = 1;
  /* Ciclo su i che indica tutte le cifre della rappresentazione binaria */
  for(i=0;i<32;i++) {
    /* Incremento il risultato aggiungendo
       il prodotto tra la i-esima cifra binaria e la i-esima potenza di 2 */
    ris += numbin[i] * pot2;
    /* Passo alla potenza di 2 successiva */
    pot2 *= 2;
  }
  /* restituisco il valore del risultato alla funzione chiamante */
  return(ris);
}
/* ### */
void dec2bin(numdec,numbin)
    unsigned int numdec;
    unsigned char numbin[];
{
  /* Definizione di un contatore i */
  int i;
  /* Ciclo su i che indica tutte le cifre della rappresentazione binaria */
  for(i=0;i<32;i++) {
    /* Pongo la i-esima cifra binaria uguale al resto di numdec / 2 */
    numbin[i] = numdec % 2;
    /* Ridefinisco numdec uguale al quoziente di numdec / 2 */
    numdec /= 2;
  }
  return;
}
/* ### */
void molbin(fatbin1,fatbin2,risbin)
    unsigned char fatbin1[];
    unsigned char fatbin2[];
    unsigned char risbin[];
{
  /* Definizione di due contatori i,j */
  int i,j;
  /* Definizione di due vettori nei quali metteremo gli addendi che 
     sono via via introdotti dall'algoritmo di moltiplicazione */
  unsigned char addbin1[32],addbin2[32];
  /* Azzeramento del risultato */

  /* Ciclo su j che considera tutte le cifre della rappresentazione
     binaria del secondo fattore */

  {
    /* Se la j-esima cifra del secondo fattore e' uguale a 0 non facciamo
       nulla, altrimenti eseguiamo il seguente ciclo di istruzioni */

    {
      /* Poniamo il primo addendo uguale al risultato */

      /* Il secondo addendo e' uguale al primo fattore traslato di
         j posizioni verso sinistra (le ultime j cifre a destra del
         secondo addendo vanno poste uguali a 0) */


      /* Riaggiorniamo il risultato ponendolo uguale alla somma del
         primo e del secondo addendo */

    }
  }
  return;
}
