#include <stdio.h>
#include <math.h>
/* Programma che effettua il calcolo della radice quadrata di un numero
   compreso tra 1 e 100 con un procedimento iterativo che migliora via
   via l'approssimazione del risultato.
   L'algoritmo di calcolo (ovviamente) fa uso dell'espansione in serie
   di potenze (arrestata al primo ordine) della funzione sqrt(1+t) con
   t prossimo a zero. */
/* ### */
/* La prossima definizione consente di cambiare facilmente il tipo di
   variabili con cui si effettua il calcolo (da double a float o il
   viceversa oppure da double ad altri tipi) */
#define DOUBLE double
/* Attenzione!
   Se si vuole utilizzare il tipo float anziche' il tipo double bisogna
   togliere le l dai formati di conversione (cioe' occorre utilizzare
   f o e anziche' lf o le, rispettivamente).
   Se si vuole utilizzare il tipo long double anziche' il tipo double
   bisogna sostituire le l con delle L nei formati di conversione (cioe'
   occorre utilizzare Lf o Le anziche' lf o le, rispettivamente). */
/* ### */
int main()
{
  /* Definizione delle variabili:
     j = contatore
     x = numero del quale vogliamo calcolare la radice quadrata
     y = numero che rappresenta l'approssimazione calcolata della radice
         quadrata di x e che viene migliorata ad ogni iterazione del metodo
     t = numero da cui si calcola facilmente la correzione da
         un'approssimazione a quella successiva
     errrel = errore relativo massimo di tolleranza che viene ammesso
              nel calcolo della radice quadrata */


  /* Inizio delle istruzioni eseguibili */
  /* Input di x */


  /* Input di errrel */


  /* Fine delle istruzioni di input */
  /* Definisco come approssimazione iniziale y della radice quadrata
     il numero intero massimo tale che il suo quadrato e' minore o uguale
     a x */


  /* Miglioro l'approssimazione della radice quadrata y del numero x,
     finche' la correzione sul valore di y non e' piu' piccola di errrel */

  {
    /* Pongo t uguale a 0.5 * ( x / (y * y) - 1 ) */

    /* Scrivo t che e' un'approssimazione dell'errore relativo attuale */

    /* Correggo l'approssimazione della radice quadrata */

    /* Eseguo il test di uscita dal ciclo: se il valore assoluto di t e'
       maggiore dell'errore relativo massimo di tolleranza, continuo
       ad iterare le correzioni del calcolo della radice quadrata */

  }
  /* Scrivo la radice quadrata del numero x di partenza */

  /* Scrivo l'errore relativo finale */

  /* Conclusione delle istruzioni eseguibili */
  exit(0);
}
