#include <stdio.h>
/* trig_ric.c : file sorgente di un programma che calcola in modo
                ricorsivo l'espansione di cos(nx) e sen(nx) in
                funzione delle potenze di cos x e sen x */
/* ### */
/* La prossima definizione consente di cambiare facilmente il
   coefficiente intero n massimo delle funzioni cos(nx) e sen(nx) di
   cui vogliamo calcolare gli sviluppi */
#define NMAX 25
/* Definizione dei prototipi delle funzioni */
void cosn(int svil[], int n);
void senn(int svil[], int n);
void stampasvil(int svil[], int n);
/* ### */
int main()
{
  /* Definizione delle variabili:
     n = coefficiente intero di cos(nx) e sen(nx)
     svil = vettore di coefficienti interi che rappresenta
            lo sviluppo delle funzioni cos(nx) e sen(nx) */
  int n, svil[NMAX+1];
  /* Fase di input del coefficiente intero n */


  /* Nel vettore svil riportiamo il calcolo dello sviluppo di
     cos(nx) */

  /* Stampiamo "cos nx =  " */

  /* Stampiamo lo sviluppo descritto dal vettore svil */

  /* Nel vettore svil riportiamo il calcolo dello sviluppo di
     sen(nx) */

  /* Stampiamo "sen nx =  " */

  /* Stampiamo lo sviluppo descritto dal vettore svil */

  exit(0);
}
/* ### */
void cosn(svil, n)
     int svil[];
     int n;
    /* Nota: questa function e' stata scritta in modo tale che
             il calcolo dello sviluppo di cos(nx) sia ricorsivo */
{
  /* Definizione di un contatore i */
  int i;
  /* Definizione di svilnmen1 che e' un vettore di n coefficienti
     interi che rappresenta lo sviluppo delle funzioni cos((n-1)x) o
     sen((n-1)x) */
  int svilnmen1[NMAX];
  /* Test di fine ricorsione: n e' uguale a 1? */

  {
    /* Quando n=1, dobbiamo semplicemente scrivere lo sviluppo di cos(x) */


  }
  /* altrimenti */

  {
    /* Nel vettore svilnmen1 riportiamo il calcolo ricorsivo
       dello sviluppo di cos((n-1)x) */

    /* Eseguiamo un ciclo sul contatore i che va da 0 a n-1 in modo da
       riportare nel vettore svil il prodotto di cos(x)*cos((n-1)x) */


    /* Azzeriamo l'elemento n-esimo di svil (perche' corrisponde
       al coefficiente di sen^n(x) ) */

    /* Nel vettore svilnmen1 riportiamo ora il calcolo ricorsivo
       dello sviluppo di sen((n-1)x) */

    /* Eseguiamo un ciclo sul contatore i che va da 1 a n in modo da
       aggiungere allo sviluppo precedente nel vettore svil il
       prodotto di -sen(x)*sen((n-1)x) */


  }
  /* Uscita dalla funzione */

}
/* ### */
void senn(svil, n)
     int svil[];
     int n;
    /* Nota: questa function e' stata scritta in modo tale che
             il calcolo dello sviluppo di sen(nx) sia ricorsivo */
{
  /* Definizione di un contatore i */
  int i;
  /* Definizione di svilnmen1 che e' un vettore (definito
     dinamicamente) di n coefficienti interi che rappresenta lo
     sviluppo delle funzioni cos((n-1)x) o sen((n-1)x) */
  int svilnmen1[NMAX];
  /* Test di fine ricorsione: n e' uguale a 1? */

  {
    /* Quando n=1, dobbiamo semplicemente scrivere lo sviluppo di sen(x) */


  }
  /* altrimenti */

  {
    /* Nel vettore svilnmen1 riportiamo il calcolo ricorsivo
       dello sviluppo di cos((n-1)x) */

    /* Eseguiamo un ciclo sul contatore i che va da 1 a n in modo da
       riportare nel vettore svil il prodotto di sen(x)*cos((n-1)x) */


    /* Azzeriamo l'elemento 0-esimo di svil (perche' corrisponde
       al coefficiente di cos^n(x) ) */

    /* Nel vettore svilnmen1 riportiamo ora il calcolo ricorsivo
       dello sviluppo di sen((n-1)x) */

    /* Eseguiamo un ciclo sul contatore i che va da 0 a n-1 in modo da
       aggiungere allo sviluppo precedente nel vettore svil il
       prodotto di cos(x)*sen((n-1)x) */


  }
  /* Uscita dalla funzione */

}
/* ### */
void stampasvil(svil, n)
     int svil[];
     int n;
{
  /* Definizione di un contatore i */
  int i;
  /* Definizione di una variabile intera nscritti che conta il numero
     di termini scritti dell'espansione */
  int nscritti;
  /* Azzero nscritti */

  /* Ciclo su i che va da 0 a n per scrivere tutti i termini dello
     sviluppo */

  {
    /* Stampiamo un termine solo se svil[i] e' diverso da zero */

    {
      /* Ogni 2 termini scritti dell'espansione stampiamo un ritorno a capo
	 e qualche spazio */


      /* Se nscritti>0 e svil[i]>0 stampiamo il segno + */


      /* Stampiamo l'i-esimo coefficiente dello sviluppo */

      /* Se i<n stampiamo cos^n-i x */


      /* Se i>0 stampiamo sen^i x */


      /* Se il termine che abbiamo stampato non e' l'ultimo della riga
	 stampiamo uno spazio per separare un termine rispetto
	 all'altro */


      /* Incrementiamo il numero di termini scritti */

    }
  }
  /* Stampa il ritorno a capo */

  return;
}
